/*
 * Copyright 2013 twiliofaces.org.
 *
 * Licensed under the Eclipse Public License version 1.0, available at
 * http://www.eclipse.org/legal/epl-v10.html
 */ 
package org.twiliofaces.component;

import static org.twiliofaces.util.NounAttributes.language;
import static org.twiliofaces.util.NounAttributes.value;
import static org.twiliofaces.util.NounAttributes.voice;
import static org.twiliofaces.util.NounAttributes.loop;
import static org.twiliofaces.util.TagUtils.addAttribute;
import static org.twiliofaces.util.TagUtils.addText;
import static org.twiliofaces.util.TagUtils.end;
import static org.twiliofaces.util.TagUtils.start;
import static org.twiliofaces.util.Verbs.Say;
import static org.twiliofaces.util.Verbs.say;

import java.io.IOException;

import javax.faces.component.FacesComponent;
import javax.faces.context.FacesContext;

import org.twiliofaces.component.api.Component;

@FacesComponent(say)
public class Say extends Component {

	@Override
	public void encodeBegin(FacesContext context) throws IOException {
		start(context, Say.name());
		addAttribute(context, getAttributes(), voice.name());
		addAttribute(context, getAttributes(), language.name());
		addAttribute(context, getAttributes(), loop.name());
	}

	@Override
	public void encodeEnd(FacesContext context) throws IOException {
		addText(context, getAttributes(), value.name());
		end(context, Say.name());
	}

}